#ifndef _ADOS_H_
#define _ADOS_H_

/***
Copyright (c) 1991, 1992 by Frank J. Edwards
See the file COPYRIGHT in this distribution for copyright details.
***/

#ident "$Id: ados.h,v 1.16 1992/11/20 04:03:11 root Rel root $"

#if NO_STRLOG + NO_SERIAL + NO_PARALLEL + NO_PRINTF != 4
# define TYPICAL	MODULE_ID, __LINE__, LOG_KERN|LOG_DEBUG, SL_TRACE
# define DBG		ados_DBG1(TYPICAL); ados_DBG2
# define IN_FUNC(x)	DBG("In function " # x, 0, 0, 0)
#endif /* any debugging at all... */

#include "sys/types.h"
#include "sys/strlog.h"
#include "sys/syslog.h"

#include "ados_root.h"
#include "ados_anode.h"
#include "ados_dir.h"
#include "ados_vfs.h"

struct afid {
    u_short	afid_len;
    int		afid_key;
};

#define ADOS_VFS(vfsp)	((struct ados *)((vfsp)->vfs_data))
#define AROOT(x)	((struct a_rdir *)(x))
#define AUDIR(x)	((struct a_udir *)(x))
#define AFILE(x)	((struct a_file *)(x))

#define NULLAP		(anode_t *)0
#define NULLAPP		(anode_t **)0

extern struct vfsops   ados_vfsops;
extern struct vnodeops ados_vnops;

#include "ados_proto.h"

#endif /* _ADOS_H_ */
