#ifndef _ADOS_FILE_H
#define _ADOS_FILE_H

/***
Copyright (c) 1991, 1992 by Frank J. Edwards
See the file COPYRIGHT in this distribution for copyright details.
***/

#ident "$Id: ados_file.h,v 1.8 1992/11/20 04:03:11 root Rel root $"

/***********************************************************************
-  Software for the AmigaDOS filesystem implementation for use         -
-  on Amiga Unix 2.0 and later.                                        -
-                                                                      -
-  Copyright (c) 1991 by Frank J. Edwards                              -
-  All rights reserved.                                                -
***********************************************************************/

/*
 *	Many of the structures and define's in this file are derived from
 *	documentation located either in the AmigaDOS Manual, 3rd Edition,
 *	or from include file(s)/comments in /usr/amiga/src directory tree.
 */

#include <sys/types.h>
#include "ados_defs.h"
#include "ados_date.h"

struct a_file {
    ulong	uf_type;	/* T.SHORT (2) */
    ulong	uf_hkey;	/* Header key (pointer to self) */
    ulong	uf_hiseq;	/* Total number of data blocks */
    ulong	uf_hashsz;	/* Data block slots used (uf_data) */
    ulong	uf_block0;	/* First data block */
    ulong	uf_chksm;	/* Balance-to-zero checksum */
    ulong	uf_data[NUMHASH];
    ulong	uf_rsvp1[2];	/* Always 0 */
    ulong	uf_prot;	/* Protection bits for this file */
    ulong	uf_size;	/* Byte size */
    ulong	uf_comment[23];	/* Comment as BCPL string */
    DateStamp	uf_cstmp;	/* Datestamp of last DIR-modified time */
    uchar	uf_name[64];	/* File name (currently <= 30) */
    ulong	uf_hashchn;	/* Pointer to next file in hash chain */
    ulong	uf_parent;	/* Pointer to parent of this entry */
    ulong	uf_exten;	/* Extension block */
    long	uf_type2;	/* ST_FILE (-3) */
};

struct a_data {
    ulong	fd_type;	/* T.DATA (x) */
    ulong	fd_hkey;	/* Block number of file's keyblk */
    ulong	fd_seqno;	/* Sequence number of this block */
    ulong	fd_datasz;	/* Number of valid LONGs in this block */
    ulong	fd_next;	/* Block number of next data block */
    ulong	fd_chksm;	/* Balance-to-zero checksum */
};

#endif /* _ADOS_FILE_H */
