#ifndef _PROTO_H
#define _PROTO_H

/* blocks.c */
int walkchn(int dos, vnode_t *dvp, LONG *block, int bsize, struct llchain *fill);
void freechn(anode_t *ap);

/* debug.c */
char *ados_debug_fmtv(char *buf, char *fmt, void *args);
char *ados_debug_fmt(char *buf, char *fmt, ...);
void ados_DBG1(int mid, int sid, int log, int level);
void pKPutChar(char ch);
void ados_DBG2(char *fmt, ...);

/* subr.c */
int extend_chain(register struct ados *afsp, register int count);
void dump_chain(char *type, register anode_t *start);
int aget(struct vfs *vfsp, ulong key, anode_t **app);
void ados_aput(register anode_t *ap);
int aflush(struct vfs *vfsp, int force);
int syncap(anode_t *ap, int flags);
void apfree(register anode_t *ap);
void ados_update(void);
int ados_flusha(struct vfs *vfsp, short flag);

/* subr2.c */
int ados_cache_dir(vnode_t *dvp, anode_t *ap);
int reada(anode_t *ap, struct uio *uiop, int ioflag);

/* util.c */
timestruc_t *date2unix(DateStamp *ds);
DateStamp *time2ados(time_t timex);
mode_t modes2unix(LONG type, LONG prot);
int ados_read_anode(register anode_t *ap, LONG key, struct vfs *vfsp);
anode_t *ados_searchdir(vnode_t *dvp, char *nm, struct cred *cr);
int ados_dotsearch(struct ados *afsp, anode_t *dnp, char *nm, struct cred *cr, anode_t **npp, off_t *offp);
int ados_naccess(anode_t *ap, int mode, struct cred *cr);

/* vfsops.c and vnops.c are not included here.  See the source file. */

#endif /* _PROTO_H */
