#ifndef _ADOS_ROOT_H
#define _ADOS_ROOT_H

/***
Copyright (c) 1991, 1992 by Frank J. Edwards
See the file COPYRIGHT in this distribution for copyright details.
***/

#ident "$Id: ados_root.h,v 1.7 1992/11/20 04:03:11 root Rel root $"

/***********************************************************************
-  Software for the AmigaDOS filesystem implementation for use         -
-  on Amiga Unix 2.0 and later.                                        -
-                                                                      -
-  Copyright (c) 1991 by Frank J. Edwards                              -
-  All rights reserved.                                                -
***********************************************************************/

/*
 *	Many of the structures and define's in this file are derived from
 *	documentation located either in the AmigaDOS Manual, 3rd Edition,
 *	or from include file(s)/comments in /usr/amiga/src directory tree.
 */

#include <sys/types.h>
#include "ados_defs.h"
#include "ados_date.h"

struct a_rdir {
    ulong	rd_type;	/* T.SHORT (2) */
    ulong	rd_rsvp1[2];	/* always 0 */
    ulong	rd_hashsz;	/* block_size (in longs) - 56 */
    ulong	rd_rsvp2[1];	/* always 0 */
    ulong	rd_chksm;	/* balance-to-zero checksum */
    ulong	rd_hash[NUMHASH];
    ulong	rd_bmflag;	/* TRUE if bmap on disk is valid */
    ulong	rd_bmapkey[BMAPSIZE];	/* blocks containing the bmap(s) */
    ulong	rd_bmapex;	/* 0, or block containing bmap extension */
    DateStamp	rd_dirstmp;	/* datestamp of last DIR-modified time */
    uchar	rd_name[NAMESIZE];	/* volume name (BSTR) */
    DateStamp	rd_dskstmp;	/* datestamp of last DISK-modified time */
    DateStamp	rd_madstmp;	/* datestamp of DISK-formatted time */
    ulong	rd_rsvp3[2];	/* always 0 */
    ulong	rd_dircache;	/* Non-zero block number if DOS3 */
    long	rd_type2;	/* ST_ROOT (1) */
};

#endif /* _ADOS_ROOT_H */
