#ifndef _ADOS_UDIR_H
#define _ADOS_UDIR_H

/***
Copyright (c) 1991, 1992 by Frank J. Edwards
See the file COPYRIGHT in this distribution for copyright details.
***/

#ident "$Id: ados_udir.h,v 1.7 1992/11/20 04:03:11 root Rel root $"

/***********************************************************************
-  Software for the AmigaDOS filesystem implementation for use         -
-  on Amiga Unix 2.0 and later.                                        -
-                                                                      -
-  Copyright (c) 1991 by Frank J. Edwards                              -
-  All rights reserved.                                                -
***********************************************************************/

/*
 *	Many of the structures and define's in this file are derived from
 *	documentation located either in the AmigaDOS Manual, 3rd Edition,
 *	or from include file(s)/comments in /usr/amiga/src directory tree.
 */

#include <sys/types.h>
#include "ados_defs.h"
#include "ados_date.h"

struct a_udir {
    ulong	ud_type;	/* T.SHORT (2) */
    ulong	ud_hkey;	/* header key (pointer to self) */
    ulong	ud_rsvp1[3];	/* always 0 */
    ulong	ud_chksm;	/* balance-to-zero checksum */
    ulong	ud_hash[NUMHASH];
    ulong	ud_rsvp2[2];	/* always 0 */
    ulong	ud_prot;	/* Protection bits for this directory */
    ulong	ud_rsvp3[1];	/* always 0 */
    ulong	ud_comment[23];	/* Contains character data */
    DateStamp	ud_dirstmp;	/* datestamp of last DIR-modified time */
    uchar	ud_name[36];	/* directory name */
    ulong	ud_rsvp4[7];	/* always 0 */
    ulong	ud_hashchn;	/* pointer to next file in hash chain */
    ulong	ud_parent;	/* pointer to parent of this entry */
    ulong	ud_dircache;	/* Non-zero block number for DOS3 */
    long	ud_type2;	/* ST_USERDIR (2) */
};

#endif /* _ADOS_UDIR_H */
