/* adosfs_defs.h 930817 Niklas allqvist <niklas@appli.se> */

/* Adapted from Frank J. Edwards' Amix AmigaDOS FS implementation.  */

#ifndef _ADOSFS_ADOSFS_DEFS_H_
#define _ADOSFS_ADOSFS_DEFS_H_

/***
Copyright (c) 1991, 1992 by Frank J. Edwards
See the file COPYRIGHT in this distribution for copyright details.
***/

#define PT_DIR		2		/* Primary types (xx_type) */
#define PT_FILE		2
#define PT_LIST		16		/* Type for file extension block */

#define ST_ROOT		1		/* Secondary types (xx_type2) */
#define ST_USERDIR	2
#define ST_SOFTLINK	3
#define ST_LINKDIR	4
#define ST_FILE		-3
#define ST_LINKFILE	-4

#define NUMHASH		((512 / sizeof (ados_u_long)) - 56)
#define HASHSIZE	(NUMHASH * sizeof (ados_u_long))
#define BMAPSIZE	(25)
#define NAMESIZE	(10 * sizeof (ados_long))

typedef long ados_long;
typedef unsigned long ados_u_long;
typedef unsigned char ados_u_char;

extern int adosfs_debug;

#define AD_VNOPS   01
#define AD_VFSOPS  02
#define AD_BLOCKS  04
#define AD_UTIL   010
#endif /* _ADOSFS_ADOSFS_DEFS_H_ */
