/* adosfs_proto.h 930819 Niklas Hallqvist <niklas@appli.se> */

/* Adapted from Frank J. Edwards' Amix AmigaDOS FS implementation.  */

#ifndef _ADOSFS_ADOSFS_PROTO_H
#define _ADOSFS_ADOSFS_PROTO_H

/* adosfs_blocks.c */
int adosfs_walkchn(int, struct vnode *, ados_long *, int, struct llchain *,
	           struct buf*);
void adosfs_freechn(struct anode *);
struct llchain *adosfs_allocchn (struct llchain *);
struct llchain *adosfs_addblk (struct llchain *, ados_long);
int adosfs_getblk (struct anode *, int, ados_u_long *);

/* adosfs_anode.c */
int aget (struct adosfsmount *, ados_u_long, struct anode **);
void aput (struct anode *);
void alock (struct anode *);
void aunlock (struct anode *);

/* adosfs_util.c */
struct timeval *date2unix (DateStamp *);
DateStamp *time2ados (time_t);
mode_t modes2unix (ados_long, ados_long);
int adosfs_cache_dir (struct vnode *, struct anode *, struct buf *);
int adosfs_read_anode (struct anode *, ados_u_long, struct adosfsmount *);

/* adosfs_vfsops.c and adosfs_vnops.c are not included here.
   See the source file. */

#endif /* _ADOSFS_ADOSFS_PROTO_H */
